/* DJE 11/3/24 
  Flash Storage doesn't work on SAMD21 since all of flash is erased every download!
*/
#include <FlashStorage_SAMD.h>

const int EE_START_ADDRESS  = 0;


// Force Calibrations to EEPROM. 
void eeWriteCalForce(unsigned char chan, unsigned char range, unsigned int C, unsigned int M ){
  unsigned int EEaddr;
  if(range > (F_CAL_NUM - 1)) range = 0;
  chan &= 0x03L;      // Make 2 bits
  EEaddr = (range * F_CAL_SIZ) + (chan * F_CAL_NUM);   // Calculate address from chan and total size
  Serial.print ("addr = "); Serial.println (EEaddr);
  Serial.print ("range = "); Serial.println (range);

}

// Initialize write EEPROM force settings for one channel C = 8000, M = FFFF
void EEFInit(unsigned char chan){
  int addr = 0;
  unsigned short C = 0x8000; 
  unsigned short M = 0x4242; 
  int startAddr = 0; 

  startAddr = chan * F_CAL_NUM * F_CAL_SIZ;
  for (addr = 0; addr < (4 * F_CAL_NUM); addr +=4) {
    //  int eeAddress = START_ADDRESS + sizeof(WRITTEN_SIGNATURE);   //Location we want the data to be put.
    //One simple call, with the address first and the object second.
    EEPROM.put(startAddr + addr, C);
    EEPROM.put(startAddr + addr + 2, M);
    Serial.print("EE Addr = "); Serial.println(startAddr + addr, DEC);
  }
  // Data struct to store.
  // MyObject customVar =
  // {
  //   3.14159f,
  //   65,
  //   "Working!"
  // };
  // eeAddress += sizeof(float); //Move address to the next byte after float 'f'.
  // EEPROM.put(eeAddress, customVar);
  EEPROM.commit();

}


void EEFPrint (unsigned char chan){       // Print one channel's force cal data
  int addr = 0;
  int startAddr = 0; 
  unsigned char value;
  unsigned short data;

  startAddr = chan * F_CAL_NUM * F_CAL_SIZ;
  Serial.print( "EE Force Cal for Chan "); Serial.println(chan);
  Serial.print(startAddr);
  for (addr = addr; addr < (4 * F_CAL_NUM); addr +=4) {
    Serial.print("  ");
    data = EEPROM.get( startAddr + addr, data);
    Serial.print(data, HEX); 
    Serial.print("-"); 
    data = EEPROM.get( startAddr + addr + 2, data);
    Serial.print(data, HEX);  

    // value = EEPROM.read(addr); // Byte ordering wrong. 
    // Serial.print(value, HEX);
    // value = EEPROM.read(addr+1);
    // Serial.print(value, HEX);

    // value = EEPROM.read(addr+2);
    // Serial.print(value, HEX);
    // value = EEPROM.read(addr+3);
    // Serial.print(value, HEX);   
  }
  Serial.println();
}